package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.ZJSY;
import com.sa.ibiz.demo.demo.service.ZJSYService;
import com.sa.ibiz.demo.demo.service.dto.ZJSYSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/zjsy")
public class ZJSYResource
{
	@Autowired
	private ZJSYService service;


	@PostMapping(value = "/remove")
	public ResponseEntity<ZJSY> remove(@Validated @RequestBody ZJSY data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("资金使用[remove]操作发生错误","ZJSY",data.getZjsyid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<ZJSY> create(@Validated @RequestBody ZJSY data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("资金使用[create]操作发生错误","ZJSY",data.getZjsyid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<ZJSY> getDraft(@Validated @RequestBody ZJSY data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("资金使用[getDraft]操作发生错误","ZJSY","");
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<ZJSY> get(@Validated @PathVariable String id){
		ZJSY data=new ZJSY();
		data.setZjsyid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("资金使用[get]操作发生错误","ZJSY",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<ZJSY> update(@Validated @RequestBody ZJSY data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("资金使用[update]操作发生错误","ZJSY",data.getZjsyid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<ZJSY> checkKey(@Validated @RequestBody ZJSY data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("资金使用[checkKey]操作发生错误","ZJSY",data.getZjsyid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<ZJSY>> searchDefaultPage(@Validated @RequestBody ZJSYSearchFilter filter){
		Page<ZJSY> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<ZJSY>> listDefault(@Validated @RequestBody ZJSYSearchFilter filter){
		List<ZJSY> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
